unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ShellCtrls, StdCtrls, Buttons, FileCtrl, CheckLst,
  ovclb, ovcbcklb, ovcbase, ovcef, ovcpb, ovcnf, ovccklb, ovcislb;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    stvDir: TShellTreeView;
    SpeedButton1: TSpeedButton;
    Memo1: TMemo;
    flbArqs: TFileListBox;
    GroupBox2: TGroupBox;
    chkExt: TCheckListBox;
    Label1: TLabel;
    GroupBox3: TGroupBox;
    ovcNum: TOvcNumericField;
    GroupBox4: TGroupBox;
    ovcIni: TOvcNumericField;
    SpeedButton2: TSpeedButton;
    chkCopy: TCheckBox;
    Memo2: TMemo;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    Label2: TLabel;
    optxta: TEdit;
    optxtd: TEdit;
    procedure ERRO_DIR;
    procedure SpeedButton1Click(Sender: TObject);
    procedure stvDirChange(Sender: TObject; Node: TTreeNode);
    procedure LISTAR();
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure BARRA();
    procedure ovcNumKeyPress(Sender: TObject; var Key: Char);
    procedure ovcNumChange(Sender: TObject);
    procedure ovcNumAfterExit(Sender: TObject);
    procedure ovcNumAfterEnter(Sender: TObject);
    procedure ovcNumEnter(Sender: TObject);
    procedure ovcNumExit(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    function VERIFICA_NOME: boolean;
  private
    { Private declarations }
  public
    { Public declarations }
    ULT_DIR : string;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ERRO_DIR;
//var
//  DIR,LINHA,D: string;
begin
  application.messagebox('Diretrio no encontrado !'+#13+'O programa ir inserir o ltimo diretrio vlido.',PChar(form1.caption),mb_ok + mb_iconerror);
  exit;

// ROTINA PARA CRIAR DIRETRIO - NO VOU ULTILIZAR
// CASO ULTILIZE, APAGAR/COMENTAR A ROTINA DE CIMA
{
  if application.messagebox('Este diretrio no existe! Deseja cri-lo?',PChar(form1.caption),mb_yesno + mb_iconquestion) = 6 then
    begin
      Edit1.text := StringReplace(edit1.text, '/', '\',[rfIgnoreCase, rfReplaceAll]);
      LINHA := edit1.text;
      D := '';
      while pos('\',LINHA) > 0 do
        begin
          DIR := copy(LINHA,1,pos('\',LINHA));
          D := D + DIR;
          if not directoryexists(D) then
            begin
              createdir(D);
            end;
          LINHA := copy(LINHA,pos('\',LINHA)+1,length(LINHA));
        end;
    end
  else
    Edit1.text := Extractfilepath(Application.ExeName);

  if directoryexists(Extractfilepath(Application.ExeName) + Edit1.text) then
    Edit1.text := Extractfilepath(Application.ExeName) + Edit1.text;

  if not directoryexists(Edit1.text) then
    begin
      application.MessageBox('No foi possvel criar este diretrio !',PChar(form1.caption),mb_ok + mb_iconerror);
      LINHA := edit1.text;
      D := '';
      while pos('\',LINHA) > 0 do
        begin
          DIR := copy(LINHA,1,pos('\',LINHA));
          D := D + DIR;
          if directoryexists(D) then
            begin
              edit1.text := D;
            end;
          LINHA := copy(LINHA,pos('\',LINHA)+1,length(LINHA));
        end;
    end;
    }
end;

procedure TForm1.LISTAR;
var
  LINHA: string;
  I,J: integer;
  INSERE: boolean;
begin
  stvDir.Path := Edit1.text;

  if directoryexists(Edit1.Text) then
    flbArqs.Directory := Edit1.Text;


  chkExt.Items.clear;
  for I := 0 to flbArqs.Count - 1 do
  begin
    LINHA := flbArqs.Items[I];
    while pos('.',LINHA) > 0 do
      LINHA := copy(LINHA,pos('.',LINHA)+1,length(LINHA));

    INSERE := true;
    for J := 0 to chkExt.Items.Count - 1 do
    begin
      if chkExt.Items[J] = '*.' + LINHA then
        INSERE := false;
    end;
    if INSERE = true then
      chkExt.Items.add('*.' + LINHA);
  end;
  ULT_DIR := Edit1.text;

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if directoryexists(Extractfilepath(Application.ExeName) + Edit1.text) then
    edit1.text := Extractfilepath(Application.ExeName) + Edit1.text;

  BARRA;

  if not directoryexists(Edit1.text) then
  begin
    ERRO_DIR;
    Edit1.text := ULT_DIR;
    edit1.setfocus;
    edit1.selstart := 0;
    edit1.sellength := length(edit1.text);
  end;


  LISTAR;
end;

procedure TForm1.stvDirChange(Sender: TObject; Node: TTreeNode);
begin
  Edit1.text := stvDir.Path;
  BARRA;
  LISTAR;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  if not fileexists(Extractfilepath(Application.ExeName) + 'info.inf') then
  begin
    Edit1.text := Extractfilepath(Application.ExeName);
    ovcNum.AsInteger := 3;
    ovcIni.AsInteger := 1;
    chkCopy.checked := false;
  end
  else
  begin
    Memo1.lines.loadfromfile(Extractfilepath(Application.ExeName) + 'info.inf');
    Edit1.text := Memo1.lines[0];
    ovcNum.AsInteger := strtoint(Memo1.lines[1]);
    ovcIni.AsInteger := strtoint(Memo1.lines[2]);
    optxta.text := Memo1.lines[4];
    optxtd.text := Memo1.lines[5];
    if Memo1.lines[3] = 'T' then
      chkCopy.checked := true
    else
      chkCopy.checked := false;      
    if not directoryexists(Edit1.text) then
      ERRO_DIR;
  end;

  LISTAR;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var
  I,CARAC,NUM: integer;
  NOME,NOMEINI,NOMEFIN,CAP,NOME_REL: string;
  NANT,NDEP: string;
  EXT,EXP: string;
  COPIA: boolean;
begin
  if VERIFICA_NOME = false then
    exit;

  EXT := '';
  for I := 0 to chkExt.items.count - 1 do
  begin
    if chkExt.checked[I] = true then
      EXT := EXT + chkExt.items[I] + ';';
  end;

  if EXT <> '' then
    flbArqs.Mask := EXT
  else
  begin
    application.messagebox('Selecione os tipos de arquivos para numerar !',PChar(form1.caption),mb_ok + mb_iconexclamation);
    exit;
  end;

  NANT := optxta.text;
  NDEP := optxtd.text;

  Memo1.lines.clear;
  Memo1.Lines.add(stvDir.Path);
  Memo1.Lines.add(inttostr(ovcNum.asinteger));
  Memo1.Lines.add(inttostr(ovcIni.AsInteger));
  if chkCopy.checked = true then
    Memo1.Lines.add('T')
  else
    Memo1.Lines.add('F');
  Memo1.Lines.add(optxta.text);
  Memo1.Lines.add(optxtd.text);    
  Memo1.lines.SaveToFile(Extractfilepath(Application.ExeName) + 'info.inf');
  Memo1.lines.clear;

  if chkCopy.checked = true then
  begin
    EXP := 'copiados, pois j existem arquivos com mesmo nome';
    COPIA := true
  end
  else
  begin
    EXP := 'renomeados, pois j existem arquivos com mesmo nome';
    COPIA := false;
  end;
    
  EXT := '';
  CARAC := ovcNum.AsInteger;
  NUM := ovcIni.AsInteger;
  Memo2.lines.clear;
  CAP := form1.caption;
  for I := 0 to flbArqs.Items.Count - 1 do
  begin
    form1.caption := CAP + ' - Aguarde....' + inttostr(trunc((100 * I) / flbArqs.Items.Count - 1)) + '%';
    EXT := flbArqs.Items[I];
    while pos('.',EXT) > 0 do
      EXT := copy(EXT,pos('.',EXT)+1,length(EXT));

    NOME := NANT + formatfloat(stringofchar('0',CARAC),NUM) + NDEP;
    NOMEINI := Edit1.text + flbArqs.Items[I];
    NOMEFIN := Edit1.text + NOME + '.' + EXT;
    NUM := NUM + 1;
    if COPIA = false then
    begin
      if not RenameFile(NOMEINI,NOMEFIN) then
        Memo2.lines.add('- ERRO: ' + flbArqs.Items[I] + ' <--> ' + NOME + '.' + EXT);
    end
    else
    begin
      if not CopyFile(PChar(NOMEINI), PChar(NOMEFIN), false) then
        Memo2.lines.add('- ERRO: ' + flbArqs.Items[I] + ' -+-> ' + NOME + '.' + EXT);
    end;
  end;

  form1.caption := CAP;      
  if Memo2.text = '' then
  begin
    application.messagebox(PChar('Arquivos numerados com sucesso !'
                   + #13 + '--------------------------------------------------------------------------------'
                   + #13 + 'Relatrio: '
                   + #13 + '--------------------------------------------------------------------------------'
                   + #13 + 'Arquivos Numerados: ' + inttostr(I)
                   + #13 + 'Numerao Inicial: ' + formatfloat(stringofchar('0',CARAC),ovcIni.asinteger)
                   + #13 + 'Numerao Final: ' + formatfloat(stringofchar('0',CARAC),NUM-1)),PChar(form1.caption),mb_ok + mb_iconinformation);
  end
  else
  begin
    Memo1.lines.clear;
    Memo1.lines.add('Relatrio de Erros do dia: ' + formatdatetime('dd/mm/yyyy',now) + ' e hora: ' + formatdatetime('hh:nn:ss',now));
    Memo1.lines.add('ERRO: Estes arquivos no puderam ser ' + EXP + ' !');
    Memo1.lines.add('------------------------------------------------------------------------------------------------------------');
    Memo1.lines.add(Memo2.text);
    NOME_REL := Extractfilepath(Application.ExeName) + 'REL_' + formatdatetime('dd-mm-yyyy',now) + '_' + formatdatetime('hh',now) + 'h' + formatdatetime('nn',now) + 'm' + formatdatetime('ss',now) + 's.txt';
    Memo1.lines.savetofile(NOME_REL);
    application.messagebox(PChar('Alguns arquivos no puderam ser numerados !'
                   + #13 + '--------------------------------------------------------------------------------'
                   + #13 + 'Relatrio: '
                   + #13 + '--------------------------------------------------------------------------------'
                   + #13 + 'Arquivos Numerados: ' + inttostr(I)
                   + #13 + 'Numerao Inicial: ' + formatfloat(stringofchar('0',CARAC),ovcIni.asinteger)
                   + #13 + 'Numerao Final: ' + formatfloat(stringofchar('0',CARAC),NUM-1)
                   + #13 + 'Erros: ' + inttostr(memo2.lines.count)
                   + #13
                   + #13 + 'Um relatrio de erros foi gerado em ' + NOME_REL
                   ),PChar(form1.caption),mb_ok + mb_iconinformation);
  end;

  flbArqs.Mask := '*.*';
end;

procedure TForm1.BARRA;
var
  CARAC,TEXTO: string;
  TAMANHO: integer;
begin
  TEXTO := edit1.text;
  TAMANHO := length(edit1.text);
  CARAC := copy(TEXTO,TAMANHO,1);
  if CARAC <> '\' then
    edit1.text := edit1.text + '\';

  while  pos('\\',edit1.text) > 0 do
    Edit1.text := StringReplace(edit1.text, '\\', '\',[rfIgnoreCase, rfReplaceAll]);
end;

procedure TForm1.ovcNumKeyPress(Sender: TObject; var Key: Char);
begin
  ovcNumChange(sender); 
end;

procedure TForm1.ovcNumChange(Sender: TObject);
begin
  if ovcNum.asinteger < 1 then ovcNum.asinteger := 1;
end;

procedure TForm1.ovcNumAfterExit(Sender: TObject);
begin
  ovcNumChange(sender);
end;

procedure TForm1.ovcNumAfterEnter(Sender: TObject);
begin
  ovcNumChange(sender);
end;

procedure TForm1.ovcNumEnter(Sender: TObject);
begin
  ovcNumChange(sender);
end;

procedure TForm1.ovcNumExit(Sender: TObject);
begin
  ovcNumChange(sender);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  if directoryexists(Edit1.text) then
    ULT_DIR := Edit1.text;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    speedbutton1click(sender);
end;

function TForm1.VERIFICA_NOME: boolean;
var
  TA,TD: string;
begin
  TA := optxta.text;
  TD := optxtd.text;

  if (pos('\',TA) > 0) or (pos('/',TA) > 0) or (pos('|',TA) > 0)
  or (pos(':',TA) > 0) or (pos('?',TA) > 0) or (pos('"',TA) > 0)
  or (pos('<',TA) > 0) or (pos('>',TA) > 0) or (pos('*',TA) > 0) then
  begin
    application.messagebox('O nome do arquivo no pode conter nenhum dos seguintes caracteres :'+#13+'                                        \ / | : * ? " < > ',PChar(form1.caption),mb_ok + mb_iconerror);
    optxta.setfocus;
    result := false;
    exit;
  end;

  if (pos('\',TD) > 0) or (pos('/',TD) > 0) or (pos('|',TD) > 0)
  or (pos(':',TD) > 0) or (pos('?',TD) > 0) or (pos('"',TD) > 0)
  or (pos('<',TD) > 0) or (pos('>',TD) > 0) or (pos('*',TD) > 0) then
  begin
    application.messagebox('O nome do arquivo no pode conter nenhum dos seguintes caracteres :'+#13+'                                        \ / | : * ? " < > ',PChar(form1.caption),mb_ok + mb_iconerror);
    optxtd.setfocus;
    result := false;
    exit;
  end;
end;

end.
